#include "Rule.h"

class Garden
{
public:
	Garden(void);
	~Garden(void);

	bool Pixel( int x, int y, int depth );

	void Grow( Rule* );

	int Depth() { return depth; };

	void ClearScratch();
	Fitness GetFitness( float dr, float dg, float db );

	int ClumpCount();
	int TotalCount();

private:
	void CreateChildren( Rule* rule );
	void ConnectChildren();

	Garden* child; //array

	Garden* parent;

	//References to siblings.
	Garden* u;
	Garden* d;
	Garden* l;
	Garden* r;

	bool value;

	float dr;
	float dg;
	float db;

	int s;
	int p;

	bool connected; //are children connected?
	int depth; //number of child layers
};
